; Wertstahl/G*P 6-OCT-2017 || CBMPrgStudio3.0+ Syntax
; uses code by draz
; www.wertstahl.de || wertstahl@gmx.net
;
;
;------ BASIC - bootloader ------------------------------------------------------------

z1     		= $02
z2     		= $04
d0_21     = $7f40
d800map   = $5800
colormap1 = $5c00
colormap2 = $dc00
bitmap1   = $8000
bitmap2   = $e000

;-------------------------------------------------------------------------------------


*=$0801
            byte  $0c,$08,$01,$00,$9e,$20,$32,$30,$36,$32,$00,$00,$00; 0 sys2062 ($080e)

*=$080e
            jmp   appstart

;-------------------------------------------------------------------------------------


appstart    cld                ; anti-fuckup
            sei

            lda   #$35
            sta   $01

            lda   #$00
            jsr   mus

            jmp   draz

;-------------------------------------------------------------------------------------

; here: drazLace sourcecode - obviously coded by draz, no idea where i found this

*= $0a00
draz        

; First transfer some data from the original format,
; since it's not possible to show the picture the
; way it is stored when saved from editor.

; Copy bitmap to 1337 place in memory.

            ldy #0
            sty z1
            sty z2
            lda #>bitmap1
            sta z1+1
            lda #>bitmap2
            sta z2+1
            lda (z1),y
            sta (z2),y
            iny
            bne *-5
            inc z1+1
            inc z2+1
            bne *-11

; Copy colormap.. this is so st0pid!

            dec 1
            lda #>colormap1
            sta z1+1
            lda #>colormap2
            sta z2+1
            ldx #4
            lda (z1),y
            sta (z2),y
            iny
            bne *-5
            inc z1+1
            inc z2+1
            dex
            bne *-12
            inc 1

; Also copy d800 colors. Yummie.

            lda #>d800map
            sta z1+1
            lda #$d8
            sta z2+1
            ldx #4
            lda (z1),y
            sta (z2),y
            iny
            bne *-5
            inc z1+1
            inc z2+1
            dex
            bne *-12


;---------------------------------------------------

; Now everything is done to start teh c0de pr0n.
; Screen is going to flixx0r like hell :).

; Since bitmap and colormap are placed on the same
; relative place in the two video banks, only
; dd00 (video bank) and d016 (finescroll x-position)
; have to be canged every frame.

            lda d0_21    ;RTFM to learn about VIC registers.
            sta $d021
            lda #$3b
            sta $d011
            lda #$78
            sta $d018   

;------ music infusion / ws ---------------------------------------- 
           
loop
            lda   #$00
lrp         cmp   $d012
            bne   lrp

            inc   $d020
            jsr   mus+3
            dec   $d020

;------ end music infusion / ws ----------------------------------- 

            bit $d011
            bpl *-3
            bit $d011
            bmi *-3

            lda #0
            eor #1
            sta *-3
            ora #$d8
            sta $d016
            eor #$d9
            asl
            sta $dd00

            jmp loop

;---------------------------------------------------
*= $1000
mus
incbin      "screamingeagle.bin"

*= $5800
incbin      "scream_drazimg.prg",2

;-------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------
;EOF